#
#	$Id: pMakefile,v 1.3 2002/09/25 04:35:20 nakano Exp nakano $
#
#	Makefile for GLSC libraries
#
#				Hiroshi Nakano
#

#########################################################################
#									#
#	You don't have to change this Makefile.				#
#									#
#########################################################################

###--CONFIGURATION--###
###--END-OF-CONFIGURATION--###

DIR	      = .

MAKEFILE      = Makefile
PMAKEFILE     = pMakefile

SLIBFILE      = lib$(SLIB).a
DLIBFILE      = lib$(DLIB).a
FSLIBFILE     = lib$(FSLIB).a
FDLIBFILE     = lib$(FDLIB).a

SRCDIR	      = src
SOBJDIR	      = sobj
DOBJDIR	      = dobj
FSOBJDIR      = fsobj
FDOBJDIR      = fdobj

LIBSPEC       =
XCFLAGS       = $(CFLAGS) $(CDEBUGFLAGS) -I$(SRCDIR) $(XINCS) $(LIBSPEC)

HDRS	      = $(SRCDIR)/g_bird.h \
		$(SRCDIR)/g_dev_m.h \
		$(SRCDIR)/g_dev_x.h \
		$(SRCDIR)/g_private.h \
		$(SRCDIR)/g_rename.h \
		$(SRCDIR)/g_config_p.c \
		$(SRCDIR)/g_f77name.h \
		$(SRCDIR)/glsc_ftn_p.c \
		$(SRCDIR)/glsc.h

SECONDARY_HDRS = $(SRCDIR)/g_config.h $(SRCDIR)/glsc_ftn.h

SRCS	      = $(SRCDIR)/g_area_color.c \
		$(SRCDIR)/g_bird.c \
		$(SRCDIR)/g_bird_view.c \
		$(SRCDIR)/g_box.c \
		$(SRCDIR)/g_circle.c \
		$(SRCDIR)/g_cls.c \
		$(SRCDIR)/g_contln.c \
		$(SRCDIR)/g_contln2.c \
		$(SRCDIR)/g_data_plot.c \
		$(SRCDIR)/g_def_area.c \
		$(SRCDIR)/g_def_line.c \
		$(SRCDIR)/g_def_marker.c \
		$(SRCDIR)/g_def_scale.c \
		$(SRCDIR)/g_def_text.c \
		$(SRCDIR)/g_dev_m.c \
		$(SRCDIR)/g_dev_x.c \
		$(SRCDIR)/g_device.c \
		$(SRCDIR)/g_fake_bird.c \
		$(SRCDIR)/g_f_bird_v.c \
		$(SRCDIR)/g_f_hidden.c \
		$(SRCDIR)/g_f_hidden2.c \
		$(SRCDIR)/g_hidden.c \
		$(SRCDIR)/g_hidden2.c \
		$(SRCDIR)/g_init.c \
		$(SRCDIR)/g_line_color.c \
		$(SRCDIR)/g_line_type.c \
		$(SRCDIR)/g_line_width.c \
		$(SRCDIR)/g_marker.c \
		$(SRCDIR)/g_marker_col.c \
		$(SRCDIR)/g_marker_sz.c \
		$(SRCDIR)/g_marker_tp.c \
		$(SRCDIR)/g_move.c \
		$(SRCDIR)/g_plot.c \
		$(SRCDIR)/g_point.c \
		$(SRCDIR)/g_polygon.c \
		$(SRCDIR)/g_polyline.c \
		$(SRCDIR)/g_rgb_color.c \
		$(SRCDIR)/g_sel_area.c \
		$(SRCDIR)/g_sel_line.c \
		$(SRCDIR)/g_sel_marker.c \
		$(SRCDIR)/g_sel_scale.c \
		$(SRCDIR)/g_sel_text.c \
		$(SRCDIR)/g_sformat.c \
		$(SRCDIR)/g_sleep.c \
		$(SRCDIR)/g_text.c \
		$(SRCDIR)/g_text_color.c \
		$(SRCDIR)/g_text_font.c \
		$(SRCDIR)/g_glsc+.c

OBJS	      = $(OBJDIR)/g_area_color.o \
		$(OBJDIR)/g_bird.o \
		$(OBJDIR)/g_bird_view.o \
		$(OBJDIR)/g_box.o \
		$(OBJDIR)/g_circle.o \
		$(OBJDIR)/g_cls.o \
		$(OBJDIR)/g_contln.o \
		$(OBJDIR)/g_contln2.o \
		$(OBJDIR)/g_data_plot.o \
		$(OBJDIR)/g_def_area.o \
		$(OBJDIR)/g_def_line.o \
		$(OBJDIR)/g_def_marker.o \
		$(OBJDIR)/g_def_scale.o \
		$(OBJDIR)/g_def_text.o \
		$(OBJDIR)/g_dev_m.o \
		$(OBJDIR)/g_dev_x.o \
		$(OBJDIR)/g_device.o \
		$(OBJDIR)/g_fake_bird.o \
		$(OBJDIR)/g_f_bird_v.o \
		$(OBJDIR)/g_f_hidden.o \
		$(OBJDIR)/g_f_hidden2.o \
		$(OBJDIR)/g_hidden.o \
		$(OBJDIR)/g_hidden2.o \
		$(OBJDIR)/g_init.o \
		$(OBJDIR)/g_line_color.o \
		$(OBJDIR)/g_line_type.o \
		$(OBJDIR)/g_line_width.o \
		$(OBJDIR)/g_marker.o \
		$(OBJDIR)/g_marker_col.o \
		$(OBJDIR)/g_marker_sz.o \
		$(OBJDIR)/g_marker_tp.o \
		$(OBJDIR)/g_move.o \
		$(OBJDIR)/g_plot.o \
		$(OBJDIR)/g_point.o \
		$(OBJDIR)/g_polygon.o \
		$(OBJDIR)/g_polyline.o \
		$(OBJDIR)/g_rgb_color.o \
		$(OBJDIR)/g_sel_area.o \
		$(OBJDIR)/g_sel_line.o \
		$(OBJDIR)/g_sel_marker.o \
		$(OBJDIR)/g_sel_scale.o \
		$(OBJDIR)/g_sel_text.o \
		$(OBJDIR)/g_sformat.o \
		$(OBJDIR)/g_sleep.o \
		$(OBJDIR)/g_text.o \
		$(OBJDIR)/g_text_color.o \
		$(OBJDIR)/g_text_font.o \
		$(OBJDIR)/g_glsc+.o

DIST	      = $(PMAKEFILE) $(HDRS) $(SRCS)

SUBDIRMFLAGS  =	"SRCDIR=../$(SRCDIR)" "OBJDIR=." "MAKEFILE=../$(MAKEFILE)"

MFLAGS        = "CC=$(CC)" "CFLAGS=$(CFLAGS)" "CDEBUGFLAGS=$(CDEBUGFLAGS)" \
		"FC=$(FC)" "FFLAGS=$(FFLAGS)" "FDEBUGFLAGS=$(FDEBUGFLAGS)" \
		"LDFLAGS=$(LDFLAGS)" "XLIBS=$(XLIBS)" \
		"FLIBPREFIX=$(FLIBPREFIX)" \
		"MAKE=$(MAKE)" "RM=$(RM)" "MV=$(MV)" "SHELL=$(SHELL)" \
		"GOUT=$(GOUT)" "SLIB=$(SLIB)" "DLIB=$(DLIB)" \
		"LIBDEST=$(LIBDEST)" "INCDEST=$(INCDEST)" \
		"FINCDEST=$(FINCDEST)" "BINDEST=$(BINDEST)" \
		"SHARE=$(SHARE)" "FSLIB=$(FSLIB)" "FDLIB=$(FDLIB)" \
		"RANLIB=$(RANLIB)" "INSTALL=$(INSTALL)" \
		"CONFIGS=$(CONFIGS)" "XINCS=$(XINCS)" \
		"XPRELIBS=$(XPRELIBS)" "XPOSTLIBS=$(XPOSTLIBS)"

all:		$(SLIBFILE) $(DLIBFILE) $(FSLIBFILE) $(FDLIBFILE) \
		$(SRCDIR)/glsc_ftn.h

FORCE:

$(SRCDIR)/g_config.h:	$(SRCDIR)/g_config_p.c $(MAKEFILE)
		@echo Checking g_config.h ...
		@$(CC) $(CFLAGS) $(CDEBUGFLAGS) $(CONFIGS) -E \
					    $(SRCDIR)/g_config_p.c \
		    | sed -e '/^#/d' -e 's/^int[ 	]*XXX/#define /' \
			-e 's/[ 	]*=[ 	]*/ /' -e 's/;//' \
		    | uniq >$(SRCDIR)/g_config.h.new
		@sh -c 'cmp -s $(SRCDIR)/g_config.h $(SRCDIR)/g_config.h.new \
						>/dev/null 2>&1 \
		     || $(MV) $(SRCDIR)/g_config.h.new $(SRCDIR)/g_config.h'
		@$(RM) $(SRCDIR)/g_config.h.new
		@echo Done.

$(SRCDIR)/glsc_ftn.h:	$(SRCDIR)/g_config.h $(SRCDIR)/glsc_ftn_p.c
		$(CC) $(CFLAGS) $(CDEBUGFLAGS) -E $(SRCDIR)/glsc_ftn_p.c \
		    | sed -e '/^#/d' | uniq >$@


$(SLIBFILE):	$(SOBJDIR) FORCE
		@echo Single precision library ...
		@(cd $(SOBJDIR); \
		  $(MAKE) -f ../$(MAKEFILE) ../$(SLIBFILE) \
		    LIB=$(SLIBFILE) LIBSPEC= $(SUBDIRMFLAGS) $(MFLAGS))
		@echo "Done."

$(DLIBFILE):	$(DOBJDIR) FORCE
		@echo Double precision library ...
		@(cd $(DOBJDIR); \
		  $(MAKE) -f ../$(MAKEFILE) ../$(DLIBFILE) \
		    LIB=$(DLIBFILE) LIBSPEC=-DG_DOUBLE \
		    $(SUBDIRMFLAGS) $(MFLAGS))
		@echo "Done."

$(SHARE)$(FSLIBFILE):	$(FSOBJDIR) FORCE
		@echo Single precision library for $(FC) ...
		@(cd $(FSOBJDIR); \
		  $(MAKE) -f ../$(MAKEFILE) ../$(FSLIBFILE) \
		    LIB=$(FSLIBFILE) LIBSPEC=-DG_F77LIB \
		    $(SUBDIRMFLAGS) $(MFLAGS))
		@echo "Done."

$(SHARE)$(FDLIBFILE):	$(FDOBJDIR) FORCE
		@echo Double precision library for $(FC) ...
		@(cd $(FDOBJDIR); \
		  $(MAKE) -f ../$(MAKEFILE) ../$(FDLIBFILE) \
		    LIB=$(FDLIBFILE) LIBSPEC="-DG_DOUBLE -DG_F77LIB" \
		    $(SUBDIRMFLAGS) $(MFLAGS))
		@echo "Done."

../$(LIB):	$(OBJS)
		ar cr ../$(LIB) $(OBJS)
		-$(RANLIB) ../$(LIB)

$(SOBJDIR) $(DOBJDIR) $(FSOBJDIR) $(FDOBJDIR):
		mkdir $@

install:	FORCE $(SLIBFILE) $(DLIBFILE) $(FSLIBFILE) $(FDLIBFILE) \
		    $(SRCDIR)/glsc.h $(SRCDIR)/glsc_ftn.h
		$(INSTALL) $(SRCDIR)/glsc.h $(INCDEST)
		$(INSTALL) $(SRCDIR)/glsc_ftn.h $(FINCDEST)
		$(INSTALL) $(SLIBFILE) $(LIBDEST)
		-$(RANLIB) $(LIBDEST)/$(SLIBFILE)
		$(INSTALL) $(DLIBFILE) $(LIBDEST)
		-$(RANLIB) $(LIBDEST)/$(DLIBFILE)
		@# `sh -c' is necessary for NEWS OS 3.3
		@sh -c 'test "X$(SHARE)" != X || \
		    $(MAKE) -f $(MAKEFILE) install-flibs \
			"SRCDIR=$(SRCDIR)" "MAKEFILE=$(MAKEFILE)" \
			$(MFLAGS)'

install-flibs:	FORCE $(FSLIBFILE) $(FDLIBFILE)
		$(INSTALL) $(FSLIBFILE) $(LIBDEST)
		-$(RANLIB) $(LIBDEST)/$(FSLIBFILE)
		$(INSTALL) $(FDLIBFILE) $(LIBDEST)
		-$(RANLIB) $(LIBDEST)/$(FDLIBFILE)

clean:		FORCE
		$(RM) $(SECONDARY_HDRS) \
		      $(DOBJDIR)/*.o $(SOBJDIR)/*.o \
		      $(FDOBJDIR)/*.o $(FSOBJDIR)/*.o \
		      $(SLIBFILE) $(DLIBFILE) \
		      $(FSLIBFILE) $(FDLIBFILE)

ls-dist:	$(DIST)
		@for f in $(DIST); do echo $(DIR)/$$f; done

$(DIST):
		@co -q $@

ci:		FORCE
		for f in $(DIST); do \
		    if [ -w $$f ]; then \
			if [ "$$f" = "$(PMAKEFILE)" ]; then \
			    ci -t- -u $(PMAKEFILE); \
			else \
			    ci -t- $$f; \
			fi; \
		    fi; \
		done

co:		FORCE
		-co -q -l $(DIST)

$(MAKE):

$(OBJS):	$(SRCDIR)/g_config.h $(SRCDIR)/glsc.h $(SRCDIR)/g_private.h \
		$(MAKEFILE)

$(OBJDIR)/g_area_color.o:	$(SRCDIR)/g_area_color.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_area_color.c
$(OBJDIR)/g_bird.o:		$(SRCDIR)/g_bird.c $(SRCDIR)/g_bird.h
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_bird.c
$(OBJDIR)/g_bird_view.o:	$(SRCDIR)/g_bird_view.c $(SRCDIR)/g_bird.h
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_bird_view.c
$(OBJDIR)/g_box.o:		$(SRCDIR)/g_box.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_box.c
$(OBJDIR)/g_circle.o:		$(SRCDIR)/g_circle.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_circle.c
$(OBJDIR)/g_cls.o:		$(SRCDIR)/g_cls.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_cls.c
$(OBJDIR)/g_contln.o:		$(SRCDIR)/g_contln.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_contln.c
$(OBJDIR)/g_contln2.o:		$(SRCDIR)/g_contln2.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_contln2.c
$(OBJDIR)/g_data_plot.o:	$(SRCDIR)/g_data_plot.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_data_plot.c
$(OBJDIR)/g_def_area.o:		$(SRCDIR)/g_def_area.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_def_area.c
$(OBJDIR)/g_def_line.o:		$(SRCDIR)/g_def_line.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_def_line.c
$(OBJDIR)/g_def_marker.o:	$(SRCDIR)/g_def_marker.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_def_marker.c
$(OBJDIR)/g_def_scale.o:	$(SRCDIR)/g_def_scale.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_def_scale.c
$(OBJDIR)/g_def_text.o:		$(SRCDIR)/g_def_text.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_def_text.c
$(OBJDIR)/g_dev_m.o:		$(SRCDIR)/g_dev_m.c $(SRCDIR)/g_dev_m.h
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_dev_m.c
$(OBJDIR)/g_dev_x.o:		$(SRCDIR)/g_dev_x.c $(SRCDIR)/g_dev_x.h
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_dev_x.c
$(OBJDIR)/g_device.o:		$(SRCDIR)/g_device.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_device.c
$(OBJDIR)/g_fake_bird.o:	$(SRCDIR)/g_fake_bird.c $(SRCDIR)/g_bird.h
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_fake_bird.c
$(OBJDIR)/g_f_bird_v.o:		$(SRCDIR)/g_f_bird_v.c $(SRCDIR)/g_bird.h
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_f_bird_v.c
$(OBJDIR)/g_f_hidden.o:		$(SRCDIR)/g_f_hidden.c $(SRCDIR)/g_bird.h
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_f_hidden.c
$(OBJDIR)/g_f_hidden2.o:	$(SRCDIR)/g_f_hidden2.c $(SRCDIR)/g_bird.h
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_f_hidden2.c
$(OBJDIR)/g_hidden.o:		$(SRCDIR)/g_hidden.c $(SRCDIR)/g_bird.h
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_hidden.c
$(OBJDIR)/g_hidden2.o:		$(SRCDIR)/g_hidden2.c $(SRCDIR)/g_bird.h
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_hidden2.c
$(OBJDIR)/g_init.o:		$(SRCDIR)/g_init.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_init.c
$(OBJDIR)/g_line_color.o:	$(SRCDIR)/g_line_color.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_line_color.c
$(OBJDIR)/g_line_type.o:	$(SRCDIR)/g_line_type.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_line_type.c
$(OBJDIR)/g_line_width.o:	$(SRCDIR)/g_line_width.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_line_width.c
$(OBJDIR)/g_marker.o:		$(SRCDIR)/g_marker.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_marker.c
$(OBJDIR)/g_marker_col.o:	$(SRCDIR)/g_marker_col.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_marker_col.c
$(OBJDIR)/g_marker_sz.o:	$(SRCDIR)/g_marker_sz.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_marker_sz.c
$(OBJDIR)/g_marker_tp.o:	$(SRCDIR)/g_marker_tp.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_marker_tp.c
$(OBJDIR)/g_move.o:		$(SRCDIR)/g_move.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_move.c
$(OBJDIR)/g_plot.o:		$(SRCDIR)/g_plot.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_plot.c
$(OBJDIR)/g_point.o:		$(SRCDIR)/g_point.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_point.c
$(OBJDIR)/g_polygon.o:		$(SRCDIR)/g_polygon.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_polygon.c
$(OBJDIR)/g_polyline.o:		$(SRCDIR)/g_polyline.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_polyline.c
$(OBJDIR)/g_rgb_color.o:	$(SRCDIR)/g_rgb_color.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_rgb_color.c
$(OBJDIR)/g_sel_area.o:		$(SRCDIR)/g_sel_area.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_sel_area.c
$(OBJDIR)/g_sel_line.o:		$(SRCDIR)/g_sel_line.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_sel_line.c
$(OBJDIR)/g_sel_marker.o:	$(SRCDIR)/g_sel_marker.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_sel_marker.c
$(OBJDIR)/g_sel_scale.o:	$(SRCDIR)/g_sel_scale.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_sel_scale.c
$(OBJDIR)/g_sel_text.o:		$(SRCDIR)/g_sel_text.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_sel_text.c
$(OBJDIR)/g_sformat.o:		$(SRCDIR)/g_sformat.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_sformat.c
$(OBJDIR)/g_sleep.o:		$(SRCDIR)/g_sleep.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_sleep.c
$(OBJDIR)/g_text.o:		$(SRCDIR)/g_text.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_text.c
$(OBJDIR)/g_text_color.o:	$(SRCDIR)/g_text_color.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_text_color.c
$(OBJDIR)/g_text_font.o:	$(SRCDIR)/g_text_font.c
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_text_font.c
$(OBJDIR)/g_glsc+.o:		$(SRCDIR)/g_glsc+.c 
		$(CC) $(XCFLAGS) -c $(SRCDIR)/g_glsc+.c

#
#	End of Makefile
#
